import pyglet
from Utils import *
from GameObject import *
import math
from copy import copy

class Asteroid:
    def __init__(self, pos, life, size = 3, image = 'asteroid.png'):
        self.pos = copy(pos)
        self.vel = Vector2D(randrange(-30,30),randrange(-30,30))
        self.rot =  0
        self.life = life
        self.mass = 15
        self.size = size
        self.image = pyglet.resource.image(image)
        centerImage(self.image)
        self.width,self.height = self.image.width * self.size/5,self.image.height * self.size/5
        self.sprite = pyglet.sprite.Sprite(self.image, pos.x, pos.y)
        self.sprite.scale = self.size/5.0
        
    def draw(self):
            self.sprite.position = (self.pos.x,self.pos.y)
            self.sprite.rotation = self.rot
            self.sprite.draw()

    def update(self):
        self.life -= self.world.delta
        print self.pos
        
        if len(self.world.ships) > 1:
            nearestShip = sorted(self.world.ships, key = lambda a: Distance(copy(self.pos),a.pos))[0]
            if isCircleCollide(self,nearestShip):
                self.life = 0.0
                nearestShip.life -= self.size/5 * 50
                
        if self.size > 1 and self.life <= 0.0:
            for i in range(randrange(1,2)):
                self.world.addAsteroid(Asteroid(self.pos, 10, self.size - 1))
                        
        self.pos += self.vel * self.world.delta
        
            