import pyglet
from Utils import *
from Turret import Turret
import math
from copy import copy

class Bonus:
    def __init__(self, pos, life, type):
        self.pos = copy(pos)
        self.vel = Vector2D(0.0,0.0)
        self.rot = 0
        self.life = life
        self.type = type
        self.mass = 1.0
        self.world = None
        self.image = pyglet.resource.image(self.type + "bonus.png")
        centerImage(self.image)
        self.width,self.height = self.image.width,self.image.height
        self.sprite = pyglet.sprite.Sprite(self.image, pos.x, pos.y)
        
    def draw(self):
        self.sprite.position = (self.pos.x,self.pos.y)
        self.sprite.rotation = self.rot
        self.sprite.draw()

    def update(self):
        self.life -= self.world.delta
        
        for ship in self.world.ships:
            if isCircleCollide(self,ship):
                if self.type == "life":
                    ship.life += randrange(10,20)
                elif self.type == "turret":
                    self.world.addTurret(Turret(ship.pos, randrange(1,10), randrange(10,100), randrange(10,30), randrange(600,1500), randrange(10,30),[ship]))
                self.life = 0.0
                break
            
        self.pos += self.vel * self.world.delta
        
            