import pyglet
from Utils import *
from GameObject import *
import math
from copy import copy

memo = {0:0, 1:1}
def fib(n):
    if not n in memo:
        memo[n] = fib(n-1) + fib(n-2)
    return memo[n]

class Bullet:
    def __init__(self, pos, rot, life, dmg, owner, xEq, yEq, image = 'bullet.png'):
        self.pos = copy(pos)
        self.vel = Vector2D(0.0,0.0)
        self.rot =  copy(rot)
        self.life = life
        self.mass = 0.001
        self.image = pyglet.resource.image(image)
        centerImage(self.image)
        self.width,self.height = self.image.width,self.image.height
        self.sprite = pyglet.sprite.Sprite(self.image, pos.x, pos.y)
        
        self.prevPos = self.pos

        self.dmg = dmg
        self.owner = owner
        self.x = 0
        self.xEq = xEq
        self.yEq = yEq
        
    def draw(self):
            self.sprite.position = (self.pos.x,self.pos.y)
            self.sprite.rotation = self.rot
            self.sprite.draw()
            self.sprite.position = (self.prevPos.x,self.prevPos.y)
            self.sprite.opacity = 128
            self.sprite.draw()

    def update(self):
        self.life -= self.world.delta
        
        self.x += self.world.delta
        try:
            self.vel = Vector2D(0.0,0.0)
            MoveLocal(self.vel,self.rot-90,eval(self.xEq,{},{"x":self.x,"px":self.pos.x, "py":self.pos.y, "sin":math.sin,"cos":math.cos, "tan":math.tan, "fact":math.factorial, "fib":fib, "log":math.log}))
            MoveLocal(self.vel,self.rot,eval(self.yEq,{},{"x":self.x,"px":self.pos.x, "py":self.pos.y, "sin":math.sin,"cos":math.cos, "tan":math.tan, "fact":math.factorial, "fib":fib, "log":math.log}))
        except:
            self.world.soundQueue.append(("error",copy(self.pos)))
            self.owner.xEq = '0'
            self.owner.yEq = '0'
            self.life = 0.0

        self.prevPos = copy(self.pos)
        
        if len(self.world.ships + self.world.turrets + self.world.asteroids) > 1:
            nearestShip = sorted(self.world.ships + self.world.turrets, key = lambda a: Distance(copy(self.pos),a.pos))[0]
            if isCircleCollide(self,nearestShip) and self.owner != nearestShip:
                self.life = 0.0
                nearestShip.life -= self.dmg
                
                
        self.pos += self.vel * self.world.delta
        
            