import pyglet
from Camera import Camera,glLoadIdentity
from Utils import centerImage

class GUI:
    def __init__(self, player):
        self.player = player
        self.camera = Camera(self.player, self.player.world.window.width, self.player.world.window.height)
        #self.fps_display = pyglet.clock.ClockDisplay()
        self.hpText = pyglet.text.Label("",
                          font_name='Arial',
                          font_size=34,
                          x=64, y=64,
                          anchor_x='center', anchor_y='center')
        self.eqText = pyglet.text.Label("",
                          font_name='Arial',
                          font_size=16,
                          x=self.player.world.window.width - 100, y=64,
                          anchor_x='center', anchor_y='center')
        self.eqText.text = "Equations:"
        self.xEqText = pyglet.text.Label("",
                          font_name='Arial',
                          font_size=16,
                          x=self.player.world.window.width - 100, y=48,
                          anchor_x='center', anchor_y='center')
        self.yEqText = pyglet.text.Label("",
                          font_name='Arial',
                          font_size=16,
                          x=self.player.world.window.width - 100, y=26,
                          anchor_x='center', anchor_y='center')
        
        self.lifeImage = pyglet.resource.image("life.png")
        centerImage(self.lifeImage)
        self.lifeSprite = pyglet.sprite.Sprite(self.lifeImage, 16, 64)
        
        self.guiText = pyglet.text.Label("",
                          font_name='Arial',
                          font_size=12,
                          x=128, y=64,
                          multiline = True, width = 400)
        
    def startDrawing(self):
        self.camera.setView()
        
    def endDrawing(self):
        glLoadIdentity()
        #self.fps_display.draw()
        self.lifeSprite.draw()
        self.hpText.draw()
        self.eqText.draw()
        self.xEqText.draw()
        self.yEqText.draw()
        self.guiText.draw()
        
    def update(self):
        self.hpText.text = str(int(max(0,self.player.life)))
        self.xEqText.text = "X:" + self.player.xEq
        self.yEqText.text = "Y:" + self.player.yEq
        