from Mission import *
from Ship import *
from Planet import *
from Asteroid import *
from Turret import *
from Bonus import *
from GUI import GUI
from World import *

class MainMission(Mission):
    def __init__(self,world):
        Mission.__init__(self, world)
        self.player = Ship(Vector2D(500,400), 0, 5, 70, 100, 10)
        self.world.addShip(self.player, HumanController)
        self.world.mainShip = self.world.ships[-1]
        self.gui = GUI(self.world.ships[-1])
         
        for i in range(randrange(12, 18)):
            world.addPlanet(Planet(Vector2D(randrange(0,world.width),randrange(0,world.height)),randrange(100000,10000000),"planet%d.png" % randrange(0,4)))
        
        self.musicPlayer = pyglet.media.Player()
        self.musicPlayer.queue(pyglet.resource.media("Ciastek - rapidart.ogg"))
        self.musicPlayer.eos_action = pyglet.media.Player.EOS_LOOP
        self.musicPlayer.volume = 0.6
        
    def setText(self,text, speed):
        self.gui.guiText.text = ''
        for char in text:
            self.gui.guiText.text += char
            Wait(self, speed)
    
    def spawnEnemies(self, amount, factor = 1):
        for i in range(amount):
            self.world.addShip(Ship(Vector2D(
                                           max(0,min(self.world.width,randrange(int(self.player.pos.x) - 600,int(self.player.pos.x) + 600))), 
                                           max(0,min(self.world.height,randrange(int(self.player.pos.y) - 600,int(self.player.pos.y) + 600))) 
                                           ), randrange(0,360), randrange(1,3)*factor, randrange(3,6)*factor, 30*factor, 3*factor, 'enemyShip.png'), AIController)
            if randrange(1,4) == 2:
                self.world.addBonus(Bonus(Vector2D(
                                                   max(0,min(self.world.width,randrange(int(self.player.pos.x) - 1000,int(self.player.pos.x) + 1000))), 
                                                   max(0,min(self.world.height,randrange(int(self.player.pos.y) - 1000,int(self.player.pos.y) + 1000))) 
                                                   ), 
                                          1000, "life"))
            if randrange(1,9) == 3:
                self.world.addBonus(Bonus(Vector2D(
                                                   max(0,min(self.world.width,randrange(int(self.player.pos.x) - 1000,int(self.player.pos.x) + 1000))), 
                                                   max(0,min(self.world.height,randrange(int(self.player.pos.y) - 1000,int(self.player.pos.y) + 1000))) 
                                                   ), 
                                          1000, "turret"))
                
    def spawnAsteroids(self, amount):
        for i in range(amount):
            self.world.addAsteroid(Asteroid(Vector2D(
                                                     randrange(0,self.world.width),
                                           randrange(0,self.world.height)),
                                           randrange(10,15)))
            
                
    def update(self):
        self.player.mass = 0.0
        self.setText("Hello, and welcome into *bzzt*",0.1)
        Wait(self,2)
        self.setText("\n...",0.25)
        Wait(self,2)
        self.setText("Oh, here is it!         \nI'm sorry about these fancy communication issues, but I have limited funds.", 0.08)
        Wait(self,1)
        self.setText("Only seven days, one person, own code snippets prohibition, rusted PC, lack of motivation, multi-platform problems, slow microthreads libary... ", 0.05)        
        Wait(self,1)
        self.setText("Ehh... Everything is very rough, but I hope, that you will enjoy your stay.", 0.1)
        Wait(self,1)
        self.setText("But I'm so rude, I didn't introducted myself.    \nI'm Cedric.      \nBut where you are?", 0.1)
        Wait(self,1.5)
        self.setText("You are in vat.           \nYou are not human anymore.     \nI removed brain from your body and connected its neurons to my supercomputer.     \nExciting, isn't it?",0.12)
        Wait(self,2)
        self.setText("Actually, you are in my first simulated reality - cosmos.     \nFew planets, simple use of Newton's universal gravity law and you as spaceship.     \nFascinating, eh?",0.1)
        Wait(self,2)
        self.player.mass = 10.0
        self.setText("You can move with WASD keys.          \nWhat is key?     \nYou needn't know this - this is thing from my reality.",0.1)
        Wait(self,2)
        self.setText("Shoot with Space.     \nQ and E keys allows you change function of bullet's trajectory. Confirm with Enter. Try sin(x*10)*400 as X coordinate's function.             \nReality is pretty mathematical, isn't it?",0.1)
        Wait(self,1)
        while not self.player.xEq == "sin(x*10)*400":
            Wait(self,0.00001)
        Wait(self,1)
        self.setText("You can use following functions:\nsin, cos, tan, fact, fib and log. \nPx is x coordinate of bullet, py is y coordinate and x is bullets life.",0.1)
        Wait(self,1)
        self.world.addShip(Ship(self.player.pos + Vector2D(0, 50), 45, 1, 5, 10, 3, 'enemyShip.png'), AIController)
        self.setText("Oh, enemy ship!          \nDestroy him mercilessly.",0.05)
        Wait(self,1)
        while len(self.world.ships) != 1:
            Wait(self,0.00001)
        
        self.world.addBonus(Bonus(Vector2D(
                                           max(0,min(self.world.width,randrange(int(self.player.pos.x) - 200,int(self.player.pos.x) + 200))), 
                                           max(0,min(self.world.height,randrange(int(self.player.pos.y) - 200,int(self.player.pos.y) + 200))) 
                                           ), 
                                  1000, "turret"))
        self.world.addBonus(Bonus(Vector2D(
                                           max(0,min(self.world.width,randrange(int(self.player.pos.x) - 200,int(self.player.pos.x) + 200))), 
                                           max(0,min(self.world.height,randrange(int(self.player.pos.y) - 200,int(self.player.pos.y) + 200))) 
                                           ), 
                                  1000, "life"))
        self.setText("Good.                \nLook, bonuses! Collect them.",0.1)
        Wait(self,1)
        while len(self.world.bonuses) != 0:
            Wait(self,0.00001)
            
        self.setText("Turret! Next element of my own universe. It will help you.               \nWhy you need help?",0.1)
        self.musicPlayer.play()
        self.spawnEnemies(15)
        self.spawnAsteroids(20)
        Wait(self,1)
        self.setText("Let's game begin.",0.1)
        while len(self.world.ships) != 1:
            Wait(self,0.00001)
        
        self.setText("I'm very impressed. Maybe something harder?",0.1)
        self.world.addShip(Ship(Vector2D(self.world.width/2, self.world.height/2),
                                 0, 5, 2, 200, 30, 'boss1Ship.png'), Boss1AIController)
        self.world.ships[-1].mass = 0.0
        self.spawnEnemies(5,2)
        
        while len(self.world.ships) != 1:
            Wait(self,0.00001)
        
        self.setText("Wow. You are tough test subject.        \nBut not enough tough.",0.1)
        self.spawnEnemies(6,3)
        self.world.addShip(Ship(Vector2D(self.world.width/2, self.world.height/2),
                                 0, 7, 5, 500, 50, 'boss1Ship.png'), Boss1AIController)
        self.world.addShip(Ship(Vector2D(self.world.width/2, self.world.height/2),
                                 0, 7, 5, 500, 50, 'boss1Ship.png'), Boss1AIController)
        
        while len(self.world.ships) != 1:
            Wait(self,0.00001)
            
        self.setText("Not dead already? So unfortunate. But don't worry, I can fix it.",0.1)
        Wait(self,1)
        self.setText("We need more planets...",0.1)
        for i in range(randrange(12, 18)):
            self.world.addPlanet(Planet(Vector2D(randrange(0,self.world.width),randrange(0,self.world.height)),randrange(100000,10000000),"planet%d.png" % randrange(0,4)))
        Wait(self,1)
        self.setText("..some enemies...",0.1)
        self.spawnEnemies(10,5)
        Wait(self,1)
        self.setText("...and asteroids!",0.1)
        self.spawnAsteroids(10)
        Wait(self,1)
        self.setText("I'm leaving you now, I don't have more time. If you will survive, you won.     \nBut remember, Cartesian demon always win.",0.1)
