import pyglet
from GameObject import *

class Planet:
    def __init__(self, pos, mass, image = 'planet.png'):
        self.pos = pos 

        self.image = pyglet.resource.image(image)
        centerImage(self.image)
        self.width,self.height = self.image.width,self.image.height
        self.sprite = pyglet.sprite.Sprite(self.image, pos.x, pos.y)
        
        self.mass = mass * self.height/3
                
    def draw(self):
        self.sprite.draw()
        
        
    def update(self):
        for ship in self.world.ships + self.world.bonuses:
            if Distance(ship.pos, self.pos) <= 600:
                a = (125000)*(ship.mass/DistanceSqrt(ship.pos,self.pos))
                if isCircleCollide(ship,self):
                    ship.life -= abs(a*self.world.delta)
                    MoveLocal(ship.pos,LookAt(self.pos,ship.pos),-1.2*a*self.world.delta)
                else:
                    MoveLocal(ship.pos,LookAt(self.pos,ship.pos),a*self.world.delta)

        for object in self.world.bullets:
            if Distance(object.pos, self.pos) <= 600:
                if isCircleCollide(object,self):
                    object.life = 0.0
                a = (150000)*(object.mass/DistanceSqrt(object.pos,self.pos))
                vec = Vector2D(0.0,0.0)
                MoveLocal(object.pos,LookAt(self.pos,object.pos),a*self.world.delta)
        
                