import pyglet
from pyglet.window import key

from Bullet import *

def AIController(ship):
    if ship.world.ships:
            if Distance(ship.world.mainShip.pos, ship.pos) <= 600:
                if LookAt(ship.world.mainShip.pos,ship.pos) < ship.rot:
                    ship.rot -= ship.rotSpeed
                elif LookAt(ship.world.mainShip.pos,ship.pos) > ship.rot:
                    ship.rot += ship.rotSpeed
                if ship.rot - 20 < LookAt(ship.world.mainShip.pos,ship.pos) < ship.rot + 20:
                    ship.shoot()
            ship.vel.x = max(-ship.speed*3,min(ship.vel.x, ship.speed*3))
            ship.vel.y = max(-ship.speed*3,min(ship.vel.y, ship.speed*3))
    
            if abs(ship.speed) > 1.0:
                ship.vel.x +=  -ship.speed/100.0 if ship.vel.x > 0 else ship.speed/100.0
                ship.vel.y +=  -ship.speed/100.0 if ship.vel.y > 0 else ship.speed/100.0
            MoveLocal(ship.vel,ship.rot,ship.speed)
            
            if ship.pos.x < 0:
                ship.pos.x = ship.world.width
            elif ship.pos.x > ship.world.width:
                ship.pos.x = 0
            if ship.pos.y < 0:
                ship.pos.y = ship.world.height
            elif ship.pos.y > ship.world.height:
                ship.pos.y = 0
                
    Wait(ship, 0.0001, ship.waitFunc)
    
def DeadmatchAIController(ship):
    if ship.world.ships:
        if len(ship.world.ships) > 1:
            nearestShip = sorted(ship.world.ships, key = lambda a: Distance(copy(ship.pos),a.pos))[1]

            if Distance(nearestShip.pos, ship.pos) <= 1000:
                if LookAt(nearestShip.pos,ship.pos) < ship.rot:
                    ship.rot -= ship.rotSpeed * ship.world.delta
                elif LookAt(nearestShip.pos,ship.pos) > ship.rot:
                    ship.rot += ship.rotSpeed * ship.world.delta
                if ship.rot - 30 < LookAt(nearestShip.pos,ship.pos) < ship.rot + 30:
                    ship.shoot()
            ship.vel.x = max(-ship.speed*3,min(ship.vel.x, ship.speed*3))
            ship.vel.y = max(-ship.speed*3,min(ship.vel.y, ship.speed*3))
    
            if abs(ship.speed) > 1.0:
                ship.vel.x +=  -ship.speed/100.0 if ship.vel.x > 0 else ship.speed/100.0
                ship.vel.y +=  -ship.speed/100.0 if ship.vel.y > 0 else ship.speed/100.0
            MoveLocal(ship.vel,ship.rot,ship.speed)
            
            if ship.pos.x < 0:
                ship.pos.x = ship.world.width
            elif ship.pos.x > ship.world.width:
                ship.pos.x = 0
            if ship.pos.y < 0:
                ship.pos.y = ship.world.height
            elif ship.pos.y > ship.world.height:
                ship.pos.y = 0
                
    Wait(ship, 0.0001, ship.waitFunc)

def Boss1AIController(ship):
    if ship.world.ships:
            if LookAt(ship.world.mainShip.pos,ship.pos) < ship.rot:
                ship.rot -= ship.rotSpeed
            elif LookAt(ship.world.mainShip.pos,ship.pos) > ship.rot:
                ship.rot += ship.rotSpeed
                
            ship.vel.x = max(-ship.speed*3,min(ship.vel.x, ship.speed*3))
            ship.vel.y = max(-ship.speed*3,min(ship.vel.y, ship.speed*3))
    
            if abs(ship.speed) > 1.0:
                ship.vel.x +=  -ship.speed/100.0 if ship.vel.x > 0 else ship.speed/100.0
                ship.vel.y +=  -ship.speed/100.0 if ship.vel.y > 0 else ship.speed/100.0
            MoveLocal(ship.vel,ship.rot,ship.speed)
            
            if ship.pos.x < 0:
                ship.pos.x = ship.world.width
            elif ship.pos.x > ship.world.width:
                ship.pos.x = 0
            if ship.pos.y < 0:
                ship.pos.y = ship.world.height
            elif ship.pos.y > ship.world.height:
                ship.pos.y = 0
            
            rnd = randrange(0,2)
            ship.yEq = "x*1000"
            if rnd == 0:
                ship.xEq = "cos(x*10)*500"
            elif rnd == 1:
                ship.xEq = "sin(x*50)*200"
            elif rnd == 2:
                ship.yEq = "x*2000"
                
            ship.shoot(0.3)
                
    Wait(ship, 0.0001, ship.waitFunc)
    
def HumanController(ship):
    #ship.vel = Vector2D(0.0,0.0)
    if ship.world.keys[key.W]:
        MoveLocal(ship.vel,ship.rot,ship.speed)
    elif ship.world.keys[key.S]:
        MoveLocal(ship.vel,ship.rot,-ship.speed)
    if ship.world.keys[key.A]:
        ship.rot -= ship.rotSpeed
    if ship.world.keys[key.D]:
        ship.rot += ship.rotSpeed
        
    if ship.world.keys[key.SPACE]:
        ship.shoot()
    
    if ship.world.keys[key.E]:
        hitted = False
        while not ship.world.keys[key.ENTER]:
            for k in range(129):
                if ship.world.keys[k] and not hitted:
                    ship.yEq += chr(k)
                    hitted = True
                    
            if ship.world.keys[key.BACKSPACE] and not hitted:
                ship.yEq = ship.yEq[:-1]
                hitted = True
                
            if hitted:
                for k in range(129):
                    if ship.world.keys[k]:
                        break
                else:
                    if not ship.world.keys[key.BACKSPACE]:
                        hitted = False
            Wait(ship, 0.01, ship.waitFunc)
        for k in range(129):
            ship.world.keys[k] = False
            
    if ship.world.keys[key.Q]:
        hitted = False
        while not ship.world.keys[key.ENTER]:
            for k in range(129):
                if ship.world.keys[k] and not hitted:
                    ship.xEq += chr(k)
                    hitted = True
                    
            if ship.world.keys[key.BACKSPACE] and not hitted:
                ship.xEq = ship.xEq[:-1]
                hitted = True
                
            if hitted:
                for k in range(129):
                    if ship.world.keys[k]:
                        break
                else:
                    if not ship.world.keys[key.BACKSPACE]:
                        hitted = False
            Wait(ship, 0.01, ship.waitFunc)
        for k in range(129):
            ship.world.keys[k] = False
            
    ship.vel.x = max(-ship.speed*3,min(ship.vel.x, ship.speed*3))
    ship.vel.y = max(-ship.speed*3,min(ship.vel.y, ship.speed*3))
    
    if abs(ship.speed) > 1.0:
        ship.vel.x +=  -ship.speed/100.0 if ship.vel.x > 0 else ship.speed/100.0
        ship.vel.y +=  -ship.speed/100.0 if ship.vel.y > 0 else ship.speed/100.0
    
    Wait(ship, 0.0001, ship.waitFunc)
        
class Ship(GameObject):
    def __init__(self, pos, rot, rotSpeed, speed, life, power, image = 'ship.png'):
        GameObject.__init__(self, copy(pos), Vector2D(0.0,0.0), copy(rot), life, 10.0, image)
        self.speed = speed
        self.rotSpeed = rotSpeed
        self.power = power
        self.controller = None
        self.keys = None
        self.cooldown = 0.0
        self.xEq = "0"
        self.yEq = "x*1000"
        
    def draw(self):
        self.sprite.position = (self.pos.x,self.pos.y)
        self.sprite.rotation = self.rot
        self.sprite.draw()
        
    def waitFunc(self, object, timePassed):
        object.pos += object.vel * self.world.delta
        
    def shoot(self,cooldown=0.75):
        if self.cooldown <= 0.0:
            self.world.addBullet(Bullet(self.pos, self.rot, randrange(1, 4), self.power, self, self.xEq, self.yEq))
            self.cooldown = uniform(cooldown,cooldown*2)
            self.world.soundQueue.append(("shoot",copy(self.pos)))
            
    def update(self):
        while self.life > 0.0:
            self.cooldown -= self.world.delta
            self.controller(self)
        self.world.soundQueue.append(("explosion",copy(self.pos)))

            