import pyglet
from pyglet.window import key

from Bullet import *

class Turret(GameObject):
    def __init__(self, pos, rotSpeed, life, power, los, angle, ignored, image = 'turret.png'):
        GameObject.__init__(self, copy(pos), Vector2D(0.0,0.0), 0, life, 10.0, image)
        self.rotSpeed = rotSpeed
        self.power = power
        self.los = los
        self.angle = angle
        self.ignored = ignored
        self.cooldown = 0.0
        
    def draw(self):
        self.sprite.rotation = self.rot
        self.sprite.draw()
        
    def waitFunc(self, object, timePassed):
        pass
        
    def shoot(self):
        if self.cooldown <= 0.0:
            self.world.addBullet(Bullet(self.pos, self.rot, uniform(3.0, 5.0), self.power, self, "0", "x*%d" % randrange(100,1000)))
            self.cooldown = uniform(0.25,0.5)
            
    def update(self):
        while self.life > 0.0:
            self.cooldown -= self.world.delta
            if self.world.ships:
                nearestShip = sorted(self.world.ships, key = lambda a: Distance(copy(self.pos),a.pos))[0]
                if nearestShip not in self.ignored and Distance(nearestShip.pos, self.pos) <= self.los:
                    if LookAt(nearestShip.pos,self.pos) < self.rot:
                        self.rot -= self.rotSpeed
                    elif LookAt(nearestShip.pos,self.pos) > self.rot:
                        self.rot += self.rotSpeed
                    if self.rot - self.angle < LookAt(nearestShip.pos,self.pos) < self.rot + self.angle:
                        self.shoot()
                    
            Wait(self,0.0001)
            